Package com.io7m.montarre.api

# Class MJavaInfo.Builder

java.lang.Object
com.io7m.montarre.api.MJavaInfo.Builder

Enclosing class:
  `MJavaInfo`

public static final class MJavaInfo.Builder extends Object
Builds instances of type `MJavaInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MJavaInfo`
  `build()`
  Builds a new `MJavaInfo`.
  `final MJavaInfo.Builder`
  `from(MJavaInfoType instance)`
  Fill a builder with attribute values from the provided `MJavaInfoType` instance.
  `final MJavaInfo.Builder`
  `setMainModule(String mainModule)`
  Initializes the value for the `mainModule` attribute.
  `final MJavaInfo.Builder`
  `setRequiredJDKVersion(long requiredJDKVersion)`
  Initializes the value for the `requiredJDKVersion` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final MJavaInfo.Builder from(MJavaInfoType instance)
    Fill a builder with attribute values from the provided `MJavaInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setRequiredJDKVersion

    public final MJavaInfo.Builder setRequiredJDKVersion(long requiredJDKVersion)
    Initializes the value for the `requiredJDKVersion` attribute.
    Parameters:
      `requiredJDKVersion` - The value for requiredJDKVersion
    Returns:
      `this` builder for use in a chained invocation

  - ### setMainModule

    public final MJavaInfo.Builder setMainModule(String mainModule)
    Initializes the value for the `mainModule` attribute.
    Parameters:
      `mainModule` - The value for mainModule
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public MJavaInfo build()
    Builds a new `MJavaInfo`.
    Returns:
      An immutable instance of MJavaInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing